os_coe_cluster – Add/Remove COE cluster from OpenStack Cloud — Ansible Documentation

- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# os_coe_cluster – Add/Remove COE cluster from OpenStack Cloud

New in version 2.8.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Add or Remove COE cluster from the OpenStack Container Infra service.

## Requirements

The below requirements are needed on the host that executes this module.

- openstacksdk
- openstacksdk >= 0.12.0
- python >= 2.7

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
api_timeout integer |  | How long should the socket layer wait before timing out for API calls. If this is omitted, nothing will be passed to the requests library.
auth dictionary |  | Dictionary containing auth information as needed by the cloud's auth plugin strategy. For the default password plugin, this would contain auth_url, username, password, project_name and any information about domains (for example, os_user_domain_name or os_project_domain_name) if the cloud supports them. For other plugins, this param will need to contain whatever parameters that auth plugin requires. This parameter is not needed if a named cloud is provided or OpenStack OS_* environment variables are present.
auth_type string |  | Name of the auth plugin to use. If the cloud uses something other than password authentication, the name of the plugin should be indicated here and the contents of the auth parameter should be updated accordingly.
availability_zone - |  | Ignored. Present for backwards compatibility
ca_cert string |  | A path to a CA Cert bundle that can be used as part of verifying SSL API requests. aliases: cacert
client_cert string |  | A path to a client certificate to use as part of the SSL transaction. aliases: cert
client_key string |  | A path to a client key to use as part of the SSL transaction. aliases: key
cloud raw |  | Named cloud or cloud config to operate against. If cloud is a string, it references a named cloud config as defined in an OpenStack clouds.yaml file. Provides default values for auth and auth_type. This parameter is not needed if auth is provided or if OpenStack OS_* environment variables are present. If cloud is a dict, it contains a complete cloud configuration like would be in a section of clouds.yaml.
cluster_template_id - / required |  | The template ID of cluster template.
discovery_url - |  | Url used for cluster node discovery
docker_volume_size - |  | The size in GB of the docker volume
flavor_id - |  | The flavor of the minion node for this ClusterTemplate
interface string | Choices: admin internal public ← | Endpoint URL type to fetch from the service catalog. aliases: endpoint_type
keypair - |  | Name of the keypair to use.
labels - |  | One or more key/value pairs
master_count - | Default: 1 | The number of master nodes for this cluster
master_flavor_id - |  | The flavor of the master node for this ClusterTemplate
name - / required |  | Name that has to be given to the cluster template
node_count - | Default: 1 | The number of nodes for this cluster
region_name string |  | Name of the region.
state - | Choices: present ← absent | Indicate desired state of the resource.
timeout integer | Default: 60 | Timeout for creating the cluster in minutes. Default to 60 mins if not set
validate_certs boolean | Choices: no ← yes | Whether or not SSL API requests should be verified. Before Ansible 2.3 this defaulted to `yes`. aliases: verify
wait boolean | Choices: no yes ← | Should ansible wait until the requested resource is complete.

## Notes

Note

- The standard OpenStack environment variables, such as `OS_USERNAME` may be used instead of providing explicit values.
- Auth information is driven by openstacksdk, which means that values can come from a yaml config file in /etc/ansible/openstack.yaml, /etc/openstack/clouds.yaml or ~/.config/openstack/clouds.yaml, then from standard environment variables, then finally by explicit parameters in plays. More information can be found at https://docs.openstack.org/openstacksdk/

## Examples

    # Create a new Kubernetes cluster
    - os_coe_cluster:
        name: k8s
        cluster_template_id: k8s-ha
        keypair: mykey
        master_count: 3
        node_count: 5

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
cluster complex | On success when state is 'present' | Dictionary describing the cluster.
| api_address string |  | Api address of cluster master node Sample: https://172.24.4.30:6443
| cluster_template_id string |  | The cluster_template UUID Sample: 7b1418c8-cea8-48fc-995d-52b66af9a9aa
| coe_version string |  | Version of the COE software currently running in this cluster Sample: v1.11.1
| container_version string |  | Version of the container software. Example: docker version. Sample: 1.12.6
| create_timeout integer |  | Timeout for creating the cluster in minutes. Default to 60 if not set. Sample: 60
| created_at string |  | The time in UTC at which the cluster is created Sample: 2018-08-16T10:29:45+00:00
| discovery_url string |  | Url used for cluster node discovery Sample: https://discovery.etcd.io/a42ee38e7113f31f4d6324f24367aae5
| faults dictionary |  | Fault info collected from the Heat resources of this cluster Sample: {'0': 'ResourceInError: resources[0].resources...'}
| flavor_id string |  | The flavor of the minion node for this cluster Sample: c1.c1r1
| keypair string |  | Name of the keypair to use. Sample: mykey
| labels dictionary |  | One or more key/value pairs Sample: {'key1': 'value1', 'key2': 'value2'}
| master_addresses list |  | IP addresses of cluster master nodes Sample: ['172.24.4.5']
| master_count integer |  | The number of master nodes for this cluster. Sample: 1
| master_flavor_id string |  | The flavor of the master node for this cluster Sample: c1.c1r1
| name string |  | Name that has to be given to the cluster Sample: k8scluster
| node_addresses list |  | IP addresses of cluster slave nodes Sample: ['172.24.4.8']
| node_count integer |  | The number of master nodes for this cluster. Sample: 1
| stack_id string |  | Stack id of the Heat stack Sample: 07767ec6-85f5-44cb-bd63-242a8e7f0d9d
| status string |  | Status of the cluster from the heat stack Sample: CREATE_COMLETE
| status_reason string |  | Status reason of the cluster from the heat stack Sample: Stack CREATE completed successfully
| updated_at string |  | The time in UTC at which the cluster is updated Sample: 2018-08-16T10:39:25+00:00
| uuid string |  | Unique UUID for this cluster Sample: 86246a4d-a16c-4a58-9e96ad7719fe0f9d
id string | On success when state is 'present' | The cluster UUID. Sample: 39007a7e-ee4f-4d13-8283-b4da2e037c69

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Feilong Wang (@flwang)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.